/******************************************************************************
 * Copyright 2013, Qualcomm Innovation Center, Inc.
 *
 *    All rights reserved.
 *    This file is licensed under the 3-clause BSD license in the NOTICE.txt
 *    file for this project. A copy of the 3-clause BSD license is found at:
 *
 *        http://opensource.org/licenses/BSD-3-Clause.
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the license is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the license for the specific language governing permissions and
 *    limitations under the license.
 ******************************************************************************/

#include <qcc/platform.h>
#include <stdio.h>
#include <qcc/String.h>
#include <signal.h>
#include <alljoyn/version.h>


#include <qcc/Log.h>

#include <alljoyn/BusObject.h>
#include <alljoyn/BusAttachment.h>
#include <alljoyn/Status.h>

#include <libxml/parser.h>
#include <libxml/xpath.h>
#include <libxml/xpathInternals.h>
#include <libxml/tree.h>
#include <fstream>
#include <qcc/StringUtil.h>


#include <alljoyn/about/AboutIconService.h>
#include <alljoyn/about/AboutService.h>
#include <alljoyn/about/PropertyStore.h>




using namespace std;
using namespace ajn;

using namespace services;





static SessionPort SERVICE_PORT;




static volatile sig_atomic_t s_interrupt = false;

static void SigIntHandler(int sig)
{
    s_interrupt = true;
}




class MyBusListener : public BusListener, public SessionPortListener {
    void NameOwnerChanged(const char* busName, const char* previousOwner, const char* newOwner)
    {

    }
    bool AcceptSessionJoiner(SessionPort sessionPort, const char* joiner, const SessionOpts& opts)
    {
        if (sessionPort != SERVICE_PORT) {
            printf("Rejecting join attempt on unexpected session port %d.\n", sessionPort);
            return false;
        }
        printf("Accepting join session request from %s (opts.proximity=%x, opts.traffic=%x, opts.transports=%x).\n",
               joiner, opts.proximity, opts.traffic, opts.transports);
        return true;
    }
};


/** The bus listener object. */
static MyBusListener s_busListener;

/** Top level message bus object. */
static BusAttachment* s_msgBus = NULL;




/** Register the bus object and connect, report the result to stdout, and return the status code. */
QStatus RegisterBusObject(AboutService* obj)
{
    QStatus status = s_msgBus->RegisterBusObject(*obj);

    if (ER_OK == status) {
        printf("RegisterBusObject succeeded.\n");
    } else {
        printf("RegisterBusObject failed (%s).\n", QCC_StatusText(status));
    }

    return status;
}

/** Connect to the daemon, report the result to stdout, and return the status code. */
QStatus ConnectToDaemon(const char* connectSpec = NULL)
{
    QStatus status;
    if (connectSpec) {
        status = s_msgBus->Connect(connectSpec);
    } else {


        status = s_msgBus->Connect();
    }

    if (ER_OK == status) {
        printf("Connect to '%s' succeeded.\n", s_msgBus->GetConnectSpec().c_str());
    } else {
        printf("Failed to connect to '%s' (%s).\n", s_msgBus->GetConnectSpec().c_str(), QCC_StatusText(status));
    }

    return status;
}

/** Start the message bus, report the result to stdout, and return the status code. */
QStatus StartMessageBus(void)
{
    QStatus status = s_msgBus->Start();

    if (ER_OK == status) {
        printf("BusAttachment started.\n");
    } else {
        printf("Start of BusAttachment failed (%s).\n", QCC_StatusText(status));
    }

    return status;
}

/** Create the session, report the result to stdout, and return the status code. */
QStatus CreateSession(TransportMask mask)
{
    SessionOpts opts(SessionOpts::TRAFFIC_MESSAGES, false, SessionOpts::PROXIMITY_ANY, mask);
    SessionPort sp = SERVICE_PORT;
    QStatus status = s_msgBus->BindSessionPort(sp, opts, s_busListener);

    if (ER_OK == status) {
        printf("BindSessionPort succeeded.\n");
    } else {
        printf("BindSessionPort failed (%s).\n", QCC_StatusText(status));
    }

    return status;
}

/** Advertise the service name, report the result to stdout, and return the status code. */
QStatus AdvertiseName(TransportMask mask)
{
    QStatus status = ER_BUS_ESTABLISH_FAILED;
    if (s_msgBus->IsConnected() && s_msgBus->GetUniqueName().size() > 0) {
        status = s_msgBus->AdvertiseName(s_msgBus->GetUniqueName().c_str(), mask);
        printf("AdvertiseName %s =%d\n", s_msgBus->GetUniqueName().c_str(), status);
    }
    return status;
}





void WaitForSigInt(void)
{
    while (s_interrupt == false) {
#ifdef _WIN32
        Sleep(100);
#else
        usleep(100 * 1000);
#endif
    }
}

#define SERVICE_EXIT_OK       0
#define SERVICE_OPTION_ERROR  1
#define SERVICE_CONFIG_ERROR  2





static const char versionPreamble[] =
    "AboutService version: %s\n"
    "Copyright (c) 2009-2013 Qualcomm Innovation Center, Inc.\n"
    "Licensed under the 3-clause BSD license: http://opensource.org/licenses/BSD-3-Clause\n";
//"Build: %s\n";






class PropertyStoreImpl : public PropertyStore {

  public:
    class Property {
      public:
        Property(qcc::String aKeyName) : keyname(aKeyName), bPublic(false), bWritable(false), bAnnouncable(false) { }

        Property(qcc::String aKeyName, ajn::MsgArg aValue) : keyname(aKeyName), value(aValue), bPublic(false), bWritable(false), bAnnouncable(false) { }

        Property(qcc::String aKeyName, ajn::MsgArg aValue, bool isPublic, bool isWritable, bool isAnnouncable) : keyname(aKeyName), value(aValue), bPublic(isPublic), bWritable(isWritable), bAnnouncable(isAnnouncable) { }

        void SetFlags(bool isPublic, bool isWritable, bool isAnnouncable) { bPublic = isPublic; bWritable = isWritable; bAnnouncable = isAnnouncable; }
        void SetLanguage(qcc::String aLanguage) { language = aLanguage; }

        qcc::String& GetkeyName() { return keyname; }
        const ajn::MsgArg& GetkeyValue() { return value; }
        qcc::String& GetLanguage() { return language; }

        bool GetIsPublic() { return bPublic; }
        bool GetIsWritable() { return bWritable; }
        bool GetIsAnnouncable() { return bAnnouncable; }

        void SetIsPublic(bool value) { bPublic = value; }
        void SetIsWritable(bool value) { bWritable = value; }
        void SetIsAnnouncable(bool value) { bAnnouncable = value; }

      private:
        qcc::String keyname;
        ajn::MsgArg value;
        bool bPublic;
        bool bWritable;
        bool bAnnouncable;
        qcc::String language;
    };





  public:

    PropertyStoreImpl(std::multimap<qcc::String, Property>& data)
    {
        internalMultimap = data;
        argsAnnounceData = NULL;
        argsReadData = NULL;

    }

    virtual ~PropertyStoreImpl()
    {
        if (argsReadData != NULL) {
            delete argsReadData;
            argsReadData = NULL;
        }

        if (argsAnnounceData != NULL) {
            delete argsAnnounceData;
            argsAnnounceData = NULL;
        }

    }



    virtual QStatus ReadAll(const char* languageTag, Filter filter, ajn::MsgArg& all)  {

        QStatus status = ER_OK;
        if (filter == ANNOUNCE) {

            argsAnnounceData = new MsgArg[internalMultimap.size()];

            std::multimap<qcc::String, Property>::iterator search = internalMultimap.find("DefaultLanguage");

            qcc::String defaultLanguage;
            if (search != internalMultimap.end()) {
                char*temp;
                search->second.GetkeyValue().Get("s", &temp);
                defaultLanguage.assign(temp);
            }


            int announceArgCount = 0;
            for (std::multimap<qcc::String, Property>::const_iterator it = internalMultimap.begin(); it != internalMultimap.end(); ++it) {
                qcc::String key = it->first;
                Property property = it->second;
                if (!property.GetIsAnnouncable())
                    continue;
                // check that it is from the defaultLanguage or empty.
                if (!(property.GetLanguage().empty() || property.GetLanguage().compare(defaultLanguage) == 0))
                    continue;


                status = argsAnnounceData[announceArgCount].Set("{sv}", property.GetkeyName().c_str(), new MsgArg(property.GetkeyValue()));
                argsAnnounceData[announceArgCount].SetOwnershipFlags(MsgArg::OwnsArgs, true);
                announceArgCount++;
            }
            status = all.Set("a{sv}", announceArgCount, argsAnnounceData);
            all.SetOwnershipFlags(MsgArg::OwnsArgs, true);
            //printf("ReadAll ANNOUNCE status %d\n",status);

        } else if (filter == READ) {

            if (languageTag != NULL) {                                     // check that the language is in the supported languages;
                std::multimap<qcc::String, Property>::iterator it = internalMultimap.find("SupportedLanguages");
                if (it == internalMultimap.end())
                    return ER_LANGUAGE_NOT_SUPPORTED;

                const MsgArg*stringArray;
                size_t fieldListNumElements;
                it->second.GetkeyValue().Get("as", &fieldListNumElements, &stringArray);
                bool found = false;
                for (size_t i = 0; i < fieldListNumElements; i++) {
                    char* tempString;
                    stringArray[i].Get("s", &tempString);
                    if (strcmp(tempString, languageTag) == 0) {
                        found = true;
                        break;
                    }
                }
                if (!found) {
                    return ER_LANGUAGE_NOT_SUPPORTED;
                }
            } else {
                return ER_LANGUAGE_NOT_SUPPORTED;
            }


            argsReadData = new MsgArg[internalMultimap.size()];
            int readArgCount = 0;



            for (std::multimap<qcc::String, Property>::const_iterator it = internalMultimap.begin(); it != internalMultimap.end(); ++it) {
                qcc::String key = it->first;
                Property property = it->second;
                if (!property.GetIsPublic())
                    continue;
                // check that it is from the defaultLanguage or empty.
                if (!(property.GetLanguage().empty() || property.GetLanguage().compare(languageTag) == 0))
                    continue;

                status = argsReadData[readArgCount].Set("{sv}", property.GetkeyName().c_str(), new  MsgArg(property.GetkeyValue()));
                argsReadData[readArgCount].SetOwnershipFlags(MsgArg::OwnsArgs, true);
                readArgCount++;
            }
            status = all.Set("a{sv}", readArgCount, argsReadData);
            all.SetOwnershipFlags(MsgArg::OwnsArgs, true);
            //printf("ReadAll READ status %d\n",status);
        } else {
            return ER_NOT_IMPLEMENTED;
        }
        return ER_OK;
        //printf("all.ToString() : %s\n\n", all.ToString().c_str());
    }
    virtual QStatus Update(const char* name, const char* languageTag, const ajn::MsgArg* value) { return ER_NOT_IMPLEMENTED; }
    virtual QStatus Delete(const char* name, const char* languageTag) { return ER_NOT_IMPLEMENTED; }

  private:
    MsgArg*argsAnnounceData;
    MsgArg*argsReadData;

    std::multimap<qcc::String, Property> internalMultimap;
};




class OptParse {
  public:
    enum ParseResultCode {
        PR_OK,
        PR_EXIT_NO_ERROR,
        PR_OPTION_CONFLICT,
        PR_INVALID_OPTION,
        PR_MISSING_OPTION,
        PR_INVALID_APPID

    };

    OptParse(int argc, char** argv) : argc(argc), argv(argv), internal(false) {
        port = 1000;
        appGUID.assign("000102030405060708090A0B0C0D0E0F");
    }

    ParseResultCode ParseResult();

    qcc::String GetConfigFile() const {
        return configFile;
    }

    qcc::String  GetDaemonSpec() const {
        return daemonSpec;
    }
    int  GetPort() const {
        return port;
    }
    qcc::String  GetAppID() const {
        return appGUID;
    }



    bool  GetInternal() const {
        return internal;
    }

  private:
    int argc;
    char** argv;


    bool internal;
    void PrintUsage();
    bool IsAllHex(const char* data);
    int ParseXML(const char* xmlData, std::multimap<qcc::String, PropertyStoreImpl::Property>& data);
  public:

    int ParseExternalXML(std::multimap<qcc::String, PropertyStoreImpl::Property>& data);
  private:
    qcc::String configFile;
    qcc::String daemonSpec;
    qcc::String appGUID;
    int port;
};


int OptParse::ParseExternalXML(std::multimap<qcc::String, PropertyStoreImpl::Property>& data)
{
    std::ifstream ifs(GetConfigFile().c_str());
    std::string content((std::istreambuf_iterator<char>(ifs)),
                        (std::istreambuf_iterator<char>()));

    if (content.empty()) {
        fprintf(stderr, "Unable to read XML file %s\n", GetConfigFile().c_str());
        return 1;
    }
    return ParseXML(content.c_str(), data);
}


int OptParse::ParseXML(const char* xmlData, std::multimap<qcc::String, PropertyStoreImpl::Property>& data)
{
    LIBXML_TEST_VERSION

    xmlParserCtxtPtr ctxt;             /* the parser context */
    xmlDocPtr doc;             /* the resulting document tree */
    xmlNode*root_element = NULL;
    int ret = 0;

    /* create a parser context */
    ctxt = xmlNewParserCtxt();
    if (ctxt == NULL) {
        fprintf(stderr, "Failed to allocate parser context\n");
        return 1;
    }


    doc = xmlCtxtReadMemory(ctxt, xmlData, strlen(xmlData), NULL, NULL, XML_PARSE_NOERROR | XML_PARSE_NOBLANKS);

    /* check if parsing suceeded */
    if (doc == NULL) {
        fprintf(stderr, "Unable to read  XML document\n");
        ret = 1;
    } else {
        /* check if validation suceeded */
        if (ctxt->valid == 0) {
            fprintf(stderr, "Invalid XML\n");
            ret = 1;
        } else {
            root_element = xmlDocGetRootElement(doc);

            xmlNode* configChildren = root_element->children;
            xmlNode* currentKey = configChildren->children;

            while (currentKey != NULL) {

                //printf("%s\n",currentKey->name);
                if (currentKey->type == XML_ELEMENT_NODE && currentKey->children != NULL) {
                    xmlChar* keyName = xmlGetProp(currentKey, (const xmlChar*)"name");
                    xmlNode* currentKeyLanguage = currentKey->children;

                    while (currentKeyLanguage != NULL) {
                        if (currentKeyLanguage->type == XML_ELEMENT_NODE) {
                            xmlChar* languageName = xmlGetProp(currentKeyLanguage, (const xmlChar*)"language");
                            if (currentKeyLanguage->children != NULL && currentKeyLanguage->children->content != NULL) {
                                xmlChar* language_value = currentKeyLanguage->children->content;
                                if (xmlStrEqual(keyName, (const xmlChar*)"DefaultLanguage")) {
                                    PropertyStoreImpl::Property defaultLanguage("DefaultLanguage", MsgArg("s", (const char*)language_value), true, true, true);
                                    data.insert(std::pair<qcc::String, PropertyStoreImpl::Property> ("DefaultLanguage", defaultLanguage));
                                }
                                if (xmlStrEqual(keyName, (const xmlChar*)"DeviceName")) {
                                    PropertyStoreImpl::Property deviceName("DeviceName", MsgArg("s", (const char*)language_value), true, true, true);
                                    if (languageName != NULL) {
                                        deviceName.SetLanguage((const char*)languageName);
                                    }
                                    data.insert(std::pair<qcc::String, PropertyStoreImpl::Property> ("DeviceName", deviceName));
                                }
                                if (xmlStrEqual(keyName, (const xmlChar*)"DeviceId")) {
                                    PropertyStoreImpl::Property deviceId("DeviceId", MsgArg("s", (const char*)language_value),     true, false, true);
                                    data.insert(std::pair<qcc::String, PropertyStoreImpl::Property> ("DeviceId", deviceId));
                                }
                                if (xmlStrEqual(keyName, (const xmlChar*)"Description")) {
                                    PropertyStoreImpl::Property description("Description", MsgArg("s", (const char*)language_value), true, false, false);
                                    if (languageName != NULL) {
                                        description.SetLanguage((const char*)languageName);
                                    }
                                    data.insert(std::pair<qcc::String, PropertyStoreImpl::Property> ("Description", description));
                                }
                            }
                        }
                        currentKeyLanguage = currentKeyLanguage->next;
                    }
                }
                currentKey = currentKey->next;
            }

        }

    }


    xmlCleanupParser();
    xmlMemoryDump();
    return ret;
}



void OptParse::PrintUsage() {
    qcc::String cmd = argv[0];
    cmd = cmd.substr(cmd.find_last_of('/') + 1);

    fprintf(
        stderr,
        "%s [--port|  | --config-file=FILE |  --daemonspec | --appid"
        "]\n"
        "    --daemonspec=\n"
        "       daemon spec used by the service.\n\n"
        "    --port=\n"
        "        used to bind the service.\n\n"
        "    --config-file=FILE\n"
        "        Use the specified configuration file.\n\n"
        "    --appid=\n"
        "        Use the specified it is HexString of 16 bytes (32 chars) \n\n"
        "    --version\n"
        "        Print the version and copyright string, and exit.\n",
        cmd.c_str());
}



bool OptParse::IsAllHex(const char* data)
{


    for (size_t index = 0; index < strlen(data); ++index) {
        if (!isxdigit(data[index]))
            return false;

    }
    return true;

}

OptParse::ParseResultCode OptParse::ParseResult()
{
    ParseResultCode result = PR_OK;
    int i;

    if (argc == 1) {
        internal = true;
        goto exit;
    }

    for (i = 1; i < argc; ++i) {
        qcc::String arg(argv[i]);
        if (arg.compare("--version") == 0) {
            printf(versionPreamble, "1");
            result = PR_EXIT_NO_ERROR;
            goto exit;
        } else if (arg.compare(0, sizeof("--port") - 1, "--port") == 0) {
            port = atoi(arg.substr(sizeof("--port")).c_str());
        } else if (arg.compare(0, sizeof("--daemonspec") - 1, "--daemonspec") == 0) {
            daemonSpec = arg.substr(sizeof("--daemonspec"));
        } else if (arg.compare(0, sizeof("--appid") - 1, "--appid") == 0) {
            appGUID = arg.substr(sizeof("--appid"));
            if ((appGUID.length() != 32) || (!IsAllHex(appGUID.c_str()))) {
                result = PR_INVALID_APPID;
                goto exit;
            }


        } else if (arg.compare("--config-file") == 0) {
            if (!configFile.empty() || internal) {
                result = PR_OPTION_CONFLICT;
                goto exit;
            }
            ++i;
            if (i == argc) {
                result = PR_MISSING_OPTION;
                goto exit;
            }
            configFile = argv[i];
        } else if (arg.compare(0, sizeof("--config-file") - 1, "--config-file") == 0) {
            if (!configFile.empty() || internal) {
                result = PR_OPTION_CONFLICT;
                goto exit;
            }
            configFile = arg.substr(sizeof("--config-file"));
        }  else if ((arg.compare("--help") == 0) || (arg.compare("-h") == 0)) {
            PrintUsage();
            result = PR_EXIT_NO_ERROR;
            goto exit;
        } else {
            result = PR_INVALID_OPTION;
            goto exit;
        }
    }

exit:

    internal = configFile.empty();

    switch (result) {
    case PR_OPTION_CONFLICT:
        fprintf(stderr,
                "Option \"%s\" is in conflict with a previous option.\n",
                argv[i]);
        break;

    case PR_INVALID_APPID:
        fprintf(stderr, "Invalid appid: \"%s\"\n", argv[i]);
        break;

    case PR_INVALID_OPTION:
        fprintf(stderr, "Invalid option: \"%s\"\n", argv[i]);
        break;

    case PR_MISSING_OPTION:
        fprintf(stderr, "No config file specified.\n");
        PrintUsage();
        break;

    default:
        break;
    }
    return result;
}




int main(int argc, char**argv, char**envArg) {
    QStatus status = ER_OK;
    printf("AllJoyn Library version: %s\n", ajn::GetVersion());
    printf("AllJoyn Library build info: %s\n", ajn::GetBuildInfo());
    QCC_SetLogLevels("ALLJOYN_ABOUT_SERVICE=7;");
    QCC_SetLogLevels("ALLJOYN_ABOUT_ICON_SERVICE=7;");



    OptParse opts(argc, argv);
    OptParse::ParseResultCode parseCode(opts.ParseResult());
    switch (parseCode) {
    case OptParse::PR_OK:
        break;

    case OptParse::PR_EXIT_NO_ERROR:

        return SERVICE_EXIT_OK;

    default:
        return SERVICE_OPTION_ERROR;
    }

    SERVICE_PORT = opts.GetPort();

    if (!opts.GetDaemonSpec().empty()) {
        printf("using Daemon config spec %s\n", opts.GetDaemonSpec().c_str());
    }

    if (!opts.GetAppID().empty()) {
        printf("using appID %s\n", opts.GetAppID().c_str());
    }


    printf("using port %d\n", opts.GetPort());


    std::multimap<qcc::String, PropertyStoreImpl::Property> data;
    if (opts.GetConfigFile().empty()) {
        printf("Config-file is not used\n");
    } else {
        printf("using Config-file %s\n", opts.GetConfigFile().c_str());
        if (opts.ParseExternalXML(data) != 0)
            return 1;
    }



    /* Install SIGINT handler so Ctrl + C deallocates memory properly */
    signal(SIGINT, SigIntHandler);


    /* Create message bus */
    s_msgBus = new BusAttachment("myApp", true);

    if (!s_msgBus) {
        status = ER_OUT_OF_MEMORY;
        return status;
    }


    if (ER_OK == status) {
        status = StartMessageBus();
    }

    if (ER_OK == status) {

        if (opts.GetDaemonSpec().empty()) {
            status = ConnectToDaemon();
        } else {
            status = ConnectToDaemon(opts.GetDaemonSpec().c_str());
        }

    }

    if (ER_OK == status) {
        s_msgBus->RegisterBusListener(s_busListener);
    }


    AboutService*aboutService = NULL;
    AboutIconService*aboutIconService = NULL;
    PropertyStoreImpl* propertyStoreImpl = NULL;
    if (ER_OK == status) {

        if (data.size() == 0) {
            // public.write.announce
            data.insert(std::pair<qcc::String, PropertyStoreImpl::Property> ("DefaultLanguage",  PropertyStoreImpl::Property("DefaultLanguage", MsgArg("s", "en"),     true, true, true)));
            data.insert(std::pair<qcc::String, PropertyStoreImpl::Property> ("DeviceName",  PropertyStoreImpl::Property("DeviceName", MsgArg("s", "MyDeviceName"),                     true, true, true)));
            data.insert(std::pair<qcc::String, PropertyStoreImpl::Property> ("DeviceId",  PropertyStoreImpl::Property("DeviceId", MsgArg("s", "1231232145667745675477"),       true, false, true)));
            data.insert(std::pair<qcc::String, PropertyStoreImpl::Property> ("Description",  PropertyStoreImpl::Property("Description", MsgArg("s", "This is car"),             true, false, false)));
        }



        uint8_t AppId[16];
        qcc::HexStringToBytes(opts.GetAppID(), AppId, 16);
        data.insert(std::pair<qcc::String, PropertyStoreImpl::Property> ("AppId",  PropertyStoreImpl::Property("AppId", MsgArg("ay", sizeof(AppId) / sizeof (*AppId), AppId),                                        true, false, true)));



        data.insert(std::pair<qcc::String, PropertyStoreImpl::Property> ("AppName",  PropertyStoreImpl::Property("AppName", MsgArg("s", "AboutConfig"),                            true, false, true)));
        data.insert(std::pair<qcc::String, PropertyStoreImpl::Property> ("Manufacturer",  PropertyStoreImpl::Property("Manufacturer", MsgArg("s", "Company"),              true, false, true)));
        data.insert(std::pair<qcc::String, PropertyStoreImpl::Property> ("ModelNumber",  PropertyStoreImpl::Property("ModelNumber", MsgArg("s", "Wxfy388i"),                       true, false, true)));
        // public.write.announce


        const char*languages [] = { "en", "sp", "ru" };
        data.insert(std::pair<qcc::String, PropertyStoreImpl::Property>
                        ("SupportedLanguages",  PropertyStoreImpl::Property("SupportedLanguages", MsgArg("as", sizeof(languages) / sizeof (*languages), languages), true, false, false)));
        data.insert(std::pair<qcc::String, PropertyStoreImpl::Property> ("DateOfManufacture",  PropertyStoreImpl::Property("DateOfManufacture", MsgArg("s", "10/1/2199"),                          true, false, false)));
        data.insert(std::pair<qcc::String, PropertyStoreImpl::Property> ("SoftwareVersion",  PropertyStoreImpl::Property("SoftwareVersion", MsgArg("s", "12.20.44 build 44454"),           true, false, false)));
        data.insert(std::pair<qcc::String, PropertyStoreImpl::Property> ("AJSoftwareVersion",  PropertyStoreImpl::Property("AJSoftwareVersion", MsgArg("s", ajn::GetVersion()),           true, false, false)));
        data.insert(std::pair<qcc::String, PropertyStoreImpl::Property> ("HardwareVersion",  PropertyStoreImpl::Property("HardwareVersion", MsgArg("s", "355.499. b"),                                     true, false, false)));
        data.insert(std::pair<qcc::String, PropertyStoreImpl::Property> ("SupportedUrl",  PropertyStoreImpl::Property("SupportedUrl", MsgArg("s", "http://www.alljoyn.org"),                       true, false, false)));


        propertyStoreImpl = new PropertyStoreImpl(data);



        aboutService = new AboutService(*s_msgBus, *propertyStoreImpl);

        aboutService->Register(SERVICE_PORT);
        status = RegisterBusObject(aboutService);

        uint8_t aboutIconContent[] = {  0x89, 0x50, 0x4e, 0x47, 0x0d, 0x0a, 0x1a, 0x0a, 0x00, 0x00, 0x00, 0x0d, 0x49, 0x48, 0x44, 0x52,
                                        0x00, 0x00, 0x00, 0x34, 0x00, 0x00, 0x00, 0x37, 0x08, 0x06, 0x00, 0x00, 0x00, 0x43, 0xec, 0x69,
                                        0x45, 0x00, 0x00, 0x00, 0x19, 0x74, 0x45, 0x58, 0x74, 0x53, 0x6f, 0x66, 0x74, 0x77, 0x61, 0x72,
                                        0x65, 0x00, 0x41, 0x64, 0x6f, 0x62, 0x65, 0x20, 0x49, 0x6d, 0x61, 0x67, 0x65, 0x52, 0x65, 0x61,
                                        0x64, 0x79, 0x71, 0xc9, 0x65, 0x3c, 0x00, 0x00, 0x03, 0x22, 0x69, 0x54, 0x58, 0x74, 0x58, 0x4d,
                                        0x4c, 0x3a, 0x63, 0x6f, 0x6d, 0x2e, 0x61, 0x64, 0x6f, 0x62, 0x65, 0x2e, 0x78, 0x6d, 0x70, 0x00,
                                        0x00, 0x00, 0x00, 0x00, 0x3c, 0x3f, 0x78, 0x70, 0x61, 0x63, 0x6b, 0x65, 0x74, 0x20, 0x62, 0x65,
                                        0x67, 0x69, 0x6e, 0x3d, 0x22, 0xef, 0xbb, 0xbf, 0x22, 0x20, 0x69, 0x64, 0x3d, 0x22, 0x57, 0x35,
                                        0x4d, 0x30, 0x4d, 0x70, 0x43, 0x65, 0x68, 0x69, 0x48, 0x7a, 0x72, 0x65, 0x53, 0x7a, 0x4e, 0x54,
                                        0x63, 0x7a, 0x6b, 0x63, 0x39, 0x64, 0x22, 0x3f, 0x3e, 0x20, 0x3c, 0x78, 0x3a, 0x78, 0x6d, 0x70,
                                        0x6d, 0x65, 0x74, 0x61, 0x20, 0x78, 0x6d, 0x6c, 0x6e, 0x73, 0x3a, 0x78, 0x3d, 0x22, 0x61, 0x64,
                                        0x6f, 0x62, 0x65, 0x3a, 0x6e, 0x73, 0x3a, 0x6d, 0x65, 0x74, 0x61, 0x2f, 0x22, 0x20, 0x78, 0x3a,
                                        0x78, 0x6d, 0x70, 0x74, 0x6b, 0x3d, 0x22, 0x41, 0x64, 0x6f, 0x62, 0x65, 0x20, 0x58, 0x4d, 0x50,
                                        0x20, 0x43, 0x6f, 0x72, 0x65, 0x20, 0x35, 0x2e, 0x30, 0x2d, 0x63, 0x30, 0x36, 0x30, 0x20, 0x36,
                                        0x31, 0x2e, 0x31, 0x33, 0x34, 0x37, 0x37, 0x37, 0x2c, 0x20, 0x32, 0x30, 0x31, 0x30, 0x2f, 0x30,
                                        0x32, 0x2f, 0x31, 0x32, 0x2d, 0x31, 0x37, 0x3a, 0x33, 0x32, 0x3a, 0x30, 0x30, 0x20, 0x20, 0x20,
                                        0x20, 0x20, 0x20, 0x20, 0x20, 0x22, 0x3e, 0x20, 0x3c, 0x72, 0x64, 0x66, 0x3a, 0x52, 0x44, 0x46,
                                        0x20, 0x78, 0x6d, 0x6c, 0x6e, 0x73, 0x3a, 0x72, 0x64, 0x66, 0x3d, 0x22, 0x68, 0x74, 0x74, 0x70,
                                        0x3a, 0x2f, 0x2f, 0x77, 0x77, 0x77, 0x2e, 0x77, 0x33, 0x2e, 0x6f, 0x72, 0x67, 0x2f, 0x31, 0x39,
                                        0x39, 0x39, 0x2f, 0x30, 0x32, 0x2f, 0x32, 0x32, 0x2d, 0x72, 0x64, 0x66, 0x2d, 0x73, 0x79, 0x6e,
                                        0x74, 0x61, 0x78, 0x2d, 0x6e, 0x73, 0x23, 0x22, 0x3e, 0x20, 0x3c, 0x72, 0x64, 0x66, 0x3a, 0x44,
                                        0x65, 0x73, 0x63, 0x72, 0x69, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x20, 0x72, 0x64, 0x66, 0x3a, 0x61,
                                        0x62, 0x6f, 0x75, 0x74, 0x3d, 0x22, 0x22, 0x20, 0x78, 0x6d, 0x6c, 0x6e, 0x73, 0x3a, 0x78, 0x6d,
                                        0x70, 0x3d, 0x22, 0x68, 0x74, 0x74, 0x70, 0x3a, 0x2f, 0x2f, 0x6e, 0x73, 0x2e, 0x61, 0x64, 0x6f,
                                        0x62, 0x65, 0x2e, 0x63, 0x6f, 0x6d, 0x2f, 0x78, 0x61, 0x70, 0x2f, 0x31, 0x2e, 0x30, 0x2f, 0x22,
                                        0x20, 0x78, 0x6d, 0x6c, 0x6e, 0x73, 0x3a, 0x78, 0x6d, 0x70, 0x4d, 0x4d, 0x3d, 0x22, 0x68, 0x74,
                                        0x74, 0x70, 0x3a, 0x2f, 0x2f, 0x6e, 0x73, 0x2e, 0x61, 0x64, 0x6f, 0x62, 0x65, 0x2e, 0x63, 0x6f,
                                        0x6d, 0x2f, 0x78, 0x61, 0x70, 0x2f, 0x31, 0x2e, 0x30, 0x2f, 0x6d, 0x6d, 0x2f, 0x22, 0x20, 0x78,
                                        0x6d, 0x6c, 0x6e, 0x73, 0x3a, 0x73, 0x74, 0x52, 0x65, 0x66, 0x3d, 0x22, 0x68, 0x74, 0x74, 0x70,
                                        0x3a, 0x2f, 0x2f, 0x6e, 0x73, 0x2e, 0x61, 0x64, 0x6f, 0x62, 0x65, 0x2e, 0x63, 0x6f, 0x6d, 0x2f,
                                        0x78, 0x61, 0x70, 0x2f, 0x31, 0x2e, 0x30, 0x2f, 0x73, 0x54, 0x79, 0x70, 0x65, 0x2f, 0x52, 0x65,
                                        0x73, 0x6f, 0x75, 0x72, 0x63, 0x65, 0x52, 0x65, 0x66, 0x23, 0x22, 0x20, 0x78, 0x6d, 0x70, 0x3a,
                                        0x43, 0x72, 0x65, 0x61, 0x74, 0x6f, 0x72, 0x54, 0x6f, 0x6f, 0x6c, 0x3d, 0x22, 0x41, 0x64, 0x6f,
                                        0x62, 0x65, 0x20, 0x50, 0x68, 0x6f, 0x74, 0x6f, 0x73, 0x68, 0x6f, 0x70, 0x20, 0x43, 0x53, 0x35,
                                        0x20, 0x4d, 0x61, 0x63, 0x69, 0x6e, 0x74, 0x6f, 0x73, 0x68, 0x22, 0x20, 0x78, 0x6d, 0x70, 0x4d,
                                        0x4d, 0x3a, 0x49, 0x6e, 0x73, 0x74, 0x61, 0x6e, 0x63, 0x65, 0x49, 0x44, 0x3d, 0x22, 0x78, 0x6d,
                                        0x70, 0x2e, 0x69, 0x69, 0x64, 0x3a, 0x39, 0x36, 0x42, 0x36, 0x31, 0x42, 0x42, 0x42, 0x38, 0x32,
                                        0x31, 0x45, 0x31, 0x31, 0x45, 0x31, 0x41, 0x31, 0x32, 0x46, 0x46, 0x31, 0x46, 0x36, 0x39, 0x38,
                                        0x44, 0x35, 0x42, 0x39, 0x30, 0x37, 0x22, 0x20, 0x78, 0x6d, 0x70, 0x4d, 0x4d, 0x3a, 0x44, 0x6f,
                                        0x63, 0x75, 0x6d, 0x65, 0x6e, 0x74, 0x49, 0x44, 0x3d, 0x22, 0x78, 0x6d, 0x70, 0x2e, 0x64, 0x69,
                                        0x64, 0x3a, 0x39, 0x36, 0x42, 0x36, 0x31, 0x42, 0x42, 0x43, 0x38, 0x32, 0x31, 0x45, 0x31, 0x31,
                                        0x45, 0x31, 0x41, 0x31, 0x32, 0x46, 0x46, 0x31, 0x46, 0x36, 0x39, 0x38, 0x44, 0x35, 0x42, 0x39,
                                        0x30, 0x37, 0x22, 0x3e, 0x20, 0x3c, 0x78, 0x6d, 0x70, 0x4d, 0x4d, 0x3a, 0x44, 0x65, 0x72, 0x69,
                                        0x76, 0x65, 0x64, 0x46, 0x72, 0x6f, 0x6d, 0x20, 0x73, 0x74, 0x52, 0x65, 0x66, 0x3a, 0x69, 0x6e,
                                        0x73, 0x74, 0x61, 0x6e, 0x63, 0x65, 0x49, 0x44, 0x3d, 0x22, 0x78, 0x6d, 0x70, 0x2e, 0x69, 0x69,
                                        0x64, 0x3a, 0x39, 0x36, 0x42, 0x36, 0x31, 0x42, 0x42, 0x39, 0x38, 0x32, 0x31, 0x45, 0x31, 0x31,
                                        0x45, 0x31, 0x41, 0x31, 0x32, 0x46, 0x46, 0x31, 0x46, 0x36, 0x39, 0x38, 0x44, 0x35, 0x42, 0x39,
                                        0x30, 0x37, 0x22, 0x20, 0x73, 0x74, 0x52, 0x65, 0x66, 0x3a, 0x64, 0x6f, 0x63, 0x75, 0x6d, 0x65,
                                        0x6e, 0x74, 0x49, 0x44, 0x3d, 0x22, 0x78, 0x6d, 0x70, 0x2e, 0x64, 0x69, 0x64, 0x3a, 0x39, 0x36,
                                        0x42, 0x36, 0x31, 0x42, 0x42, 0x41, 0x38, 0x32, 0x31, 0x45, 0x31, 0x31, 0x45, 0x31, 0x41, 0x31,
                                        0x32, 0x46, 0x46, 0x31, 0x46, 0x36, 0x39, 0x38, 0x44, 0x35, 0x42, 0x39, 0x30, 0x37, 0x22, 0x2f,
                                        0x3e, 0x20, 0x3c, 0x2f, 0x72, 0x64, 0x66, 0x3a, 0x44, 0x65, 0x73, 0x63, 0x72, 0x69, 0x70, 0x74,
                                        0x69, 0x6f, 0x6e, 0x3e, 0x20, 0x3c, 0x2f, 0x72, 0x64, 0x66, 0x3a, 0x52, 0x44, 0x46, 0x3e, 0x20,
                                        0x3c, 0x2f, 0x78, 0x3a, 0x78, 0x6d, 0x70, 0x6d, 0x65, 0x74, 0x61, 0x3e, 0x20, 0x3c, 0x3f, 0x78,
                                        0x70, 0x61, 0x63, 0x6b, 0x65, 0x74, 0x20, 0x65, 0x6e, 0x64, 0x3d, 0x22, 0x72, 0x22, 0x3f, 0x3e,
                                        0x9a, 0xda, 0x1c, 0x63, 0x00, 0x00, 0x0f, 0x59, 0x49, 0x44, 0x41, 0x54, 0x78, 0xda, 0xcc, 0x5a,
                                        0x09, 0x94, 0x5c, 0xc5, 0x75, 0xbd, 0xf5, 0x7f, 0xff, 0x5e, 0x66, 0x1f, 0x2d, 0x99, 0x19, 0x09,
                                        0x6d, 0x48, 0x02, 0x21, 0x81, 0x00, 0x23, 0xc0, 0x96, 0x42, 0x08, 0x36, 0xd8, 0x02, 0xd9, 0x46,
                                        0x21, 0x02, 0x8c, 0x21, 0x27, 0x9c, 0x63, 0x92, 0x90, 0xc5, 0x4b, 0x12, 0x62, 0x4e, 0x12, 0x07,
                                        0xdb, 0x49, 0x4c, 0x4c, 0x62, 0x93, 0xd8, 0x26, 0x89, 0x21, 0x76, 0x4c, 0x12, 0x8b, 0xc5, 0x36,
                                        0x16, 0x18, 0x4c, 0x08, 0x18, 0x82, 0x23, 0x96, 0x08, 0x03, 0x02, 0x04, 0x42, 0x2b, 0xda, 0x66,
                                        0xb4, 0xce, 0xbe, 0xf5, 0xf2, 0x97, 0xca, 0x7d, 0xf5, 0xab, 0x87, 0x56, 0xab, 0x7b, 0xa6, 0x35,
                                        0x92, 0x7d, 0x52, 0xe7, 0xbc, 0xf9, 0x3d, 0x7f, 0xab, 0x77, 0xeb, 0xbd, 0x77, 0xdf, 0xab, 0xaa,
                                        0xaf, 0xba, 0x93, 0x5f, 0xc5, 0x49, 0x6c, 0x33, 0x28, 0xcb, 0x28, 0xbf, 0x4c, 0x59, 0x4a, 0x99,
                                        0x49, 0x69, 0xa6, 0x78, 0x14, 0x9f, 0xd2, 0x4f, 0xe9, 0xa2, 0xbc, 0x4e, 0x79, 0x9e, 0xf2, 0x33,
                                        0xca, 0xc1, 0x93, 0xa9, 0x80, 0x3a, 0x49, 0x80, 0x2e, 0x85, 0xd6, 0x37, 0x69, 0xdf, 0xbf, 0x0c,
                                        0xd0, 0x53, 0xe2, 0x53, 0x0e, 0x54, 0xd2, 0x3b, 0xf6, 0x4e, 0x4d, 0x89, 0x22, 0x5e, 0x56, 0xec,
                                        0x5d, 0xf5, 0xf0, 0xbf, 0x27, 0x29, 0xff, 0x42, 0xf9, 0xef, 0xff, 0x0f, 0x80, 0xc4, 0x12, 0x7f,
                                        0x49, 0x30, 0x97, 0x20, 0xed, 0x22, 0xb9, 0x6a, 0x01, 0xbc, 0xf7, 0xcd, 0x80, 0x6a, 0x4c, 0xc2,
                                        0xff, 0xe9, 0x5e, 0xe4, 0xd7, 0x6e, 0xa6, 0xe2, 0x0e, 0x50, 0x08, 0x89, 0x23, 0x90, 0xee, 0xa0,
                                        0x5c, 0x0f, 0xaa, 0xc1, 0x83, 0x1e, 0x2c, 0xf0, 0xb1, 0xb0, 0x14, 0xf4, 0x53, 0x94, 0xdb, 0x28,
                                        0xff, 0x7b, 0x22, 0x0a, 0x25, 0x26, 0xf9, 0x5c, 0x9a, 0x72, 0x3b, 0xe5, 0x93, 0xf2, 0x0e, 0xed,
                                        0x17, 0x90, 0x58, 0xd4, 0x81, 0xba, 0xbf, 0xb9, 0x08, 0x8a, 0x23, 0x1f, 0xee, 0x19, 0x04, 0x5e,
                                        0xe8, 0x84, 0x0e, 0x7c, 0x63, 0x12, 0x77, 0x51, 0x3b, 0x52, 0x57, 0x2d, 0x44, 0xb8, 0xb5, 0x07,
                                        0x6a, 0x5a, 0x1d, 0xea, 0xbe, 0xb0, 0x02, 0xe1, 0x96, 0x1e, 0x64, 0xbf, 0xf2, 0x33, 0x14, 0x7e,
                                        0xbc, 0x93, 0xa0, 0x8c, 0x1a, 0xb4, 0x2e, 0x2e, 0xa6, 0x7c, 0x8d, 0xf2, 0x39, 0x4a, 0xe1, 0x17,
                                        0x65, 0xa1, 0xd9, 0x94, 0xef, 0x52, 0x2e, 0x32, 0x1e, 0x14, 0x04, 0x48, 0x5e, 0x3e, 0x1f, 0xf5,
                                        0x7f, 0xff, 0x7e, 0xb8, 0x73, 0x9b, 0x91, 0xfb, 0xf7, 0xb7, 0x30, 0x74, 0xd3, 0x23, 0xb4, 0x45,
                                        0x02, 0xc9, 0xcb, 0xe6, 0x1b, 0x2b, 0x24, 0x3f, 0x34, 0x1f, 0x99, 0x5b, 0xce, 0x37, 0x0f, 0xfb,
                                        0x4f, 0xef, 0x01, 0x32, 0x09, 0x78, 0xcb, 0x67, 0x9a, 0xff, 0x07, 0x57, 0x3d, 0x84, 0xc2, 0xe3,
                                        0x3b, 0xca, 0xdd, 0x53, 0xdc, 0xef, 0x37, 0x6c, 0xbc, 0xfd, 0x5c, 0x2d, 0x74, 0x06, 0xe5, 0x47,
                                        0x94, 0x05, 0x63, 0x67, 0xa2, 0x90, 0x6f, 0x71, 0x10, 0x1d, 0x18, 0xa1, 0x9b, 0xed, 0x43, 0xee,
                                        0x9b, 0xaf, 0x19, 0xd7, 0x72, 0x4f, 0x9b, 0x8e, 0xa6, 0x27, 0xaf, 0x36, 0xb7, 0x0c, 0x5d, 0xff,
                                        0x18, 0x86, 0x3f, 0xf5, 0x13, 0x24, 0x16, 0x4e, 0x41, 0x7e, 0xdd, 0x76, 0x04, 0xcf, 0xed, 0x43,
                                        0x62, 0xc5, 0x2c, 0x38, 0x1d, 0xf5, 0xb4, 0x5a, 0x2f, 0x54, 0xc2, 0x2d, 0xef, 0xe7, 0x12, 0xeb,
                                        0x82, 0x1f, 0xa5, 0xec, 0xf8, 0x79, 0x59, 0x48, 0x2c, 0xf3, 0x13, 0xca, 0xc2, 0xb1, 0xe0, 0x0e,
                                        0x18, 0x03, 0x33, 0x1a, 0xd1, 0x70, 0xd7, 0xa5, 0x70, 0xe6, 0x34, 0x61, 0x60, 0xc5, 0x5a, 0xa8,
                                        0x3a, 0x0f, 0x4d, 0xff, 0xb9, 0x06, 0xd9, 0xaf, 0xbf, 0xc2, 0x51, 0x67, 0xcc, 0xb4, 0x64, 0x90,
                                        0xbb, 0xe7, 0x75, 0xe8, 0xe1, 0x11, 0x3e, 0x12, 0x1a, 0xcb, 0xa9, 0x44, 0x8a, 0x96, 0xcd, 0xf3,
                                        0x7f, 0x4d, 0x6e, 0x48, 0x91, 0x03, 0x9d, 0x6a, 0x7d, 0xbe, 0x65, 0x5d, 0xf1, 0xc0, 0xc9, 0xb6,
                                        0x10, 0x7b, 0xc5, 0x5a, 0x03, 0x26, 0x12, 0x30, 0x3a, 0x56, 0x22, 0x4d, 0x4b, 0x2c, 0x6e, 0x84,
                                        0x7b, 0x76, 0x2b, 0x82, 0x1d, 0xbd, 0x48, 0xae, 0x99, 0x4f, 0x8b, 0x69, 0x44, 0xbd, 0x23, 0x70,
                                        0xda, 0xeb, 0x19, 0x23, 0x2f, 0x21, 0x71, 0x4e, 0x1b, 0xdc, 0x79, 0x2d, 0x08, 0x77, 0x6a, 0x24,
                                        0x2f, 0x9d, 0x8b, 0xa8, 0x73, 0x08, 0xc1, 0xab, 0x07, 0x79, 0x6e, 0x3a, 0x01, 0x3b, 0xc6, 0x42,
                                        0xba, 0xe0, 0x8f, 0x51, 0xa0, 0x72, 0x12, 0xc6, 0xe2, 0xb6, 0x2d, 0xa1, 0xdc, 0x47, 0xf9, 0xa0,
                                        0xa5, 0xfd, 0x09, 0x9b, 0xfb, 0x59, 0xf7, 0x43, 0xb5, 0xdc, 0xf7, 0x65, 0xf6, 0xf5, 0x31, 0x51,
                                        0x96, 0x14, 0x00, 0x35, 0x27, 0x0d, 0xe7, 0xd4, 0x14, 0xd4, 0xc2, 0x0c, 0xdc, 0x33, 0x5b, 0x8d,
                                        0xb5, 0x72, 0x0f, 0xbe, 0x8c, 0xcc, 0xcd, 0xe7, 0x41, 0x47, 0x79, 0x64, 0xbf, 0xf3, 0x12, 0xea,
                                        0x3f, 0xbb, 0xc2, 0xc4, 0x57, 0xd3, 0xfd, 0x57, 0xc2, 0x9d, 0xd3, 0x02, 0xc5, 0x01, 0x68, 0x7c,
                                        0xe0, 0x23, 0x48, 0x5d, 0x7d, 0x3a, 0xa2, 0x5d, 0xfd, 0x68, 0x7a, 0xf4, 0xd7, 0x91, 0xfe, 0xfd,
                                        0x73, 0x0d, 0x7d, 0x3b, 0x6d, 0x0d, 0xa8, 0xff, 0xd2, 0xc5, 0x48, 0x9c, 0xdd, 0x86, 0xe0, 0xad,
                                        0x6e, 0x60, 0xa4, 0x20, 0x94, 0x5e, 0xec, 0x7b, 0x6e, 0x49, 0x5c, 0x9d, 0x14, 0x97, 0xa3, 0x96,
                                        0xa4, 0x52, 0xa5, 0x13, 0x68, 0x55, 0x48, 0x7f, 0x46, 0xfe, 0x2d, 0x20, 0x78, 0x9b, 0x5e, 0x40,
                                        0xaa, 0xce, 0xdc, 0x70, 0x01, 0xbc, 0xc5, 0x1d, 0x18, 0xb9, 0x7b, 0x3d, 0x74, 0x7f, 0x36, 0xb6,
                                        0x5e, 0x48, 0x33, 0x16, 0x68, 0xa9, 0xbe, 0x1c, 0x92, 0xcb, 0x17, 0xa0, 0xf0, 0xbd, 0x1d, 0xd0,
                                        0x47, 0x02, 0x34, 0xfc, 0xd3, 0x65, 0x08, 0xa9, 0x70, 0xe1, 0x89, 0x5d, 0x04, 0x74, 0x55, 0x4c,
                                        0x12, 0xcf, 0x77, 0x19, 0x32, 0x71, 0x66, 0x36, 0x98, 0xff, 0xf3, 0x0f, 0x6e, 0xc5, 0xd0, 0xc7,
                                        0xd6, 0xd1, 0x7a, 0xc9, 0x52, 0x1d, 0x02, 0x9b, 0xb0, 0x5f, 0x3f, 0x51, 0x97, 0x53, 0xd4, 0xfe,
                                        0x0e, 0xe6, 0xf9, 0x04, 0x3a, 0x12, 0xa8, 0xbb, 0x6d, 0x05, 0xd2, 0xd7, 0x2c, 0x65, 0x0e, 0xa1,
                                        0x15, 0xbe, 0xf7, 0x32, 0xc2, 0x83, 0x03, 0xd0, 0x43, 0x39, 0xe4, 0x9f, 0xd9, 0x62, 0x72, 0x8f,
                                        0xd3, 0x9a, 0xa1, 0x55, 0x22, 0xe8, 0xbc, 0x4f, 0x70, 0x39, 0x24, 0x4e, 0x69, 0x46, 0x6a, 0xf5,
                                        0x62, 0xf8, 0xaf, 0xec, 0x45, 0xb8, 0xaf, 0x17, 0x03, 0x1f, 0x78, 0xc0, 0xb8, 0xa4, 0x8c, 0xfe,
                                        0xe0, 0x07, 0xbf, 0x0f, 0x87, 0x40, 0x0a, 0x8f, 0x6e, 0x43, 0xf2, 0x23, 0x0b, 0x51, 0xf7, 0x79,
                                        0x5a, 0x34, 0x1f, 0xa2, 0xb0, 0x6e, 0x1b, 0xaf, 0x3b, 0x95, 0xf4, 0xfc, 0x2b, 0x4b, 0x12, 0x27,
                                        0x60, 0x21, 0xcd, 0xbc, 0xe0, 0xa9, 0x67, 0xd5, 0x4c, 0x07, 0xa9, 0x1b, 0xce, 0x40, 0xfa, 0xc6,
                                        0x65, 0x70, 0x67, 0x4f, 0x41, 0x78, 0x60, 0x00, 0xc1, 0xd6, 0x83, 0x06, 0x90, 0x77, 0xf6, 0x2c,
                                        0xe8, 0x9e, 0x61, 0x84, 0x47, 0x86, 0xe8, 0xc0, 0x64, 0x2b, 0x3f, 0x80, 0xce, 0xfa, 0x88, 0x86,
                                        0x73, 0xa4, 0x37, 0x06, 0x7e, 0x36, 0x40, 0xfa, 0xd7, 0xce, 0x81, 0xe2, 0x18, 0x0f, 0x5e, 0xf7,
                                        0x10, 0xa2, 0xad, 0x39, 0x92, 0x42, 0x62, 0x2c, 0x47, 0x29, 0xc5, 0xdf, 0x3a, 0x82, 0x33, 0xb5,
                                        0x8e, 0x76, 0x88, 0x10, 0x0d, 0xe4, 0x8a, 0x79, 0xa9, 0x52, 0x8d, 0xb1, 0x7c, 0xa2, 0xc4, 0x5b,
                                        0x3d, 0x86, 0xb4, 0xa9, 0x5e, 0xbe, 0xa8, 0x4e, 0x49, 0x9e, 0x23, 0xb1, 0x22, 0x04, 0x10, 0x51,
                                        0x71, 0x51, 0xd8, 0x49, 0x27, 0xe1, 0x9d, 0x3b, 0x1b, 0x51, 0x37, 0x81, 0x74, 0xf5, 0x41, 0xa5,
                                        0x3d, 0x38, 0xd3, 0x1b, 0xe0, 0x34, 0x67, 0xe0, 0xd4, 0x27, 0x8d, 0x42, 0x4a, 0x2a, 0x04, 0xf3,
                                        0x12, 0xf2, 0xc7, 0x99, 0x33, 0x10, 0xd1, 0x92, 0x51, 0xdf, 0xa0, 0xb9, 0x2f, 0xda, 0x39, 0x68,
                                        0x40, 0x19, 0xba, 0x76, 0xa5, 0x7a, 0xe0, 0xbd, 0xa3, 0x04, 0xe8, 0x93, 0x05, 0x3d, 0xb7, 0xba,
                                        0xb7, 0xd0, 0x99, 0x29, 0x8f, 0x8d, 0xef, 0x72, 0xaa, 0xaa, 0x75, 0xa6, 0xa0, 0xc5, 0x5d, 0xa5,
                                        0x4e, 0x61, 0xa9, 0xd2, 0x9a, 0x84, 0x0e, 0x43, 0x2a, 0xdf, 0xcf, 0x11, 0x1c, 0x45, 0x6a, 0xe5,
                                        0x12, 0x44, 0xaf, 0xe7, 0xe0, 0xb1, 0x02, 0x88, 0x86, 0x69, 0x85, 0x5c, 0x81, 0xee, 0x56, 0x4f,
                                        0x20, 0x2e, 0x22, 0x06, 0x74, 0xd4, 0x37, 0xca, 0x58, 0x57, 0x86, 0xd6, 0x93, 0x57, 0x9c, 0x85,
                                        0xc2, 0x86, 0xdd, 0xc6, 0xed, 0x1a, 0xef, 0xbc, 0x92, 0xb4, 0x9e, 0xc4, 0xc0, 0x87, 0x7f, 0x00,
                                        0xff, 0xf1, 0x6d, 0x04, 0x9d, 0x7a, 0x97, 0xd1, 0x12, 0x4e, 0x2d, 0x31, 0xff, 0x61, 0x4a, 0xa3,
                                        0xa4, 0xb6, 0x6a, 0x37, 0x38, 0x48, 0x0b, 0xfd, 0x96, 0x49, 0x8a, 0x52, 0xe7, 0xac, 0x50, 0x6d,
                                        0xde, 0x34, 0xd5, 0xe2, 0x99, 0xdc, 0xa2, 0x1a, 0xc8, 0x6a, 0x8d, 0x29, 0x63, 0x85, 0x60, 0xe3,
                                        0x5e, 0x5a, 0x67, 0x08, 0xaa, 0x9e, 0xe7, 0x32, 0xb4, 0xce, 0x14, 0x82, 0x69, 0x4c, 0x33, 0xe7,
                                        0xd4, 0xc3, 0x69, 0x12, 0x2b, 0xf1, 0xbc, 0x58, 0xaa, 0x21, 0x6d, 0x5c, 0x33, 0x3a, 0x12, 0x5b,
                                        0x46, 0x2c, 0x29, 0xf1, 0xe3, 0x9c, 0x5a, 0x0f, 0xf7, 0xac, 0x76, 0xa8, 0xa9, 0x8c, 0x39, 0x3f,
                                        0x3c, 0x9e, 0xbc, 0x29, 0xe5, 0xc5, 0x05, 0xe3, 0x5a, 0x48, 0xa5, 0x55, 0x65, 0x77, 0xf3, 0xd4,
                                        0x72, 0xd5, 0x4a, 0xf3, 0x67, 0x5c, 0x2a, 0x42, 0x49, 0xb9, 0xc6, 0x02, 0xa0, 0x88, 0xf2, 0x9a,
                                        0x05, 0x67, 0xe1, 0x8d, 0x7d, 0x64, 0xb8, 0x19, 0x71, 0xa0, 0x9b, 0x02, 0xb4, 0x10, 0x33, 0x9c,
                                        0x54, 0xd2, 0x1e, 0x8d, 0xdf, 0x52, 0x87, 0xe4, 0x79, 0x73, 0xcc, 0x31, 0xf7, 0xa3, 0x37, 0x30,
                                        0x72, 0xd7, 0xb3, 0xd0, 0x23, 0x2c, 0x95, 0x56, 0xcd, 0x47, 0xe3, 0x3f, 0x5c, 0x8e, 0x70, 0x7b,
                                        0x1f, 0x06, 0x56, 0x7e, 0x1f, 0xd1, 0x9e, 0x81, 0xd8, 0xfd, 0x1c, 0x55, 0x0b, 0x28, 0x89, 0xa3,
                                        0xa7, 0xab, 0x5b, 0x88, 0xd9, 0xbc, 0xa2, 0x34, 0x38, 0xa7, 0xa1, 0xce, 0x82, 0x10, 0xbf, 0x16,
                                        0x97, 0x10, 0x5f, 0x57, 0xa6, 0xec, 0x27, 0x8b, 0xeb, 0xd8, 0xa9, 0x3b, 0xfb, 0x10, 0x91, 0xae,
                                        0x0d, 0xb3, 0x8d, 0x16, 0x62, 0x32, 0xe0, 0x35, 0xef, 0x8c, 0x0e, 0x0e, 0x42, 0xc2, 0xb0, 0xa0,
                                        0x1e, 0xc8, 0x1a, 0x4b, 0x06, 0x7b, 0x7b, 0x11, 0x52, 0x92, 0x97, 0xcc, 0x37, 0xb1, 0xe3, 0x2e,
                                        0x9a, 0x02, 0xef, 0xbd, 0x1c, 0x90, 0x54, 0x0c, 0x44, 0x06, 0xa9, 0x86, 0xb6, 0x74, 0xbc, 0x8b,
                                        0x04, 0x44, 0x25, 0xcb, 0x45, 0x94, 0xcf, 0x38, 0x33, 0x94, 0xf9, 0xad, 0x4c, 0xe7, 0x66, 0x1a,
                                        0x20, 0x39, 0x26, 0x11, 0x83, 0x72, 0xe7, 0x4f, 0x67, 0xee, 0x68, 0x35, 0xb1, 0xe3, 0x76, 0x34,
                                        0x1b, 0x77, 0x52, 0x19, 0xba, 0x99, 0x58, 0x86, 0x71, 0x12, 0xec, 0x38, 0xcc, 0x58, 0x62, 0x7d,
                                        0xb7, 0xe5, 0x00, 0xc2, 0xc3, 0x43, 0x26, 0xf0, 0x1d, 0x9e, 0x97, 0xb9, 0x50, 0xe1, 0x7f, 0x76,
                                        0x9a, 0xce, 0xc3, 0xb7, 0x7b, 0xe0, 0x5d, 0x3c, 0x0b, 0xad, 0x9b, 0x6e, 0x42, 0xd3, 0xd3, 0xd7,
                                        0xc2, 0x5d, 0x32, 0xd5, 0xc4, 0xdd, 0x04, 0x6d, 0xd6, 0xf8, 0xa4, 0xe0, 0x56, 0x84, 0xe9, 0xd2,
                                        0xe5, 0x9a, 0x0c, 0x10, 0x93, 0xb1, 0x95, 0x61, 0x37, 0x38, 0x49, 0xa4, 0x57, 0x9e, 0x49, 0xb7,
                                        0xe1, 0x74, 0x81, 0x80, 0xc2, 0x43, 0x83, 0xb1, 0x55, 0xa8, 0xb8, 0x10, 0x81, 0x00, 0x4e, 0x9c,
                                        0xde, 0x4e, 0x6b, 0x05, 0x08, 0xdf, 0x64, 0xc2, 0x6c, 0x6b, 0x86, 0x77, 0x0e, 0x69, 0x9d, 0xc4,
                                        0x31, 0x72, 0x2f, 0x27, 0xa8, 0xfd, 0xf1, 0x80, 0x64, 0xbf, 0xf5, 0x22, 0xf2, 0xdf, 0xde, 0xc8,
                                        0xb7, 0x66, 0xd0, 0x78, 0xdf, 0x47, 0x8d, 0xab, 0xb9, 0x0b, 0x5b, 0x51, 0xf7, 0xb9, 0xe5, 0x18,
                                        0xba, 0xee, 0x61, 0x5a, 0xdf, 0x05, 0xaa, 0x7b, 0x5f, 0xb3, 0xd1, 0x10, 0xa6, 0x08, 0xab, 0x04,
                                        0xa8, 0x62, 0x0c, 0xb9, 0xcc, 0x6d, 0x63, 0xc9, 0x40, 0x17, 0x02, 0x78, 0xe7, 0xcd, 0x82, 0x77,
                                        0xc1, 0x3c, 0xb8, 0xed, 0xcd, 0xf0, 0x5f, 0xdb, 0x87, 0x60, 0xdb, 0x21, 0x93, 0x87, 0x40, 0xe5,
                                        0x25, 0xae, 0x0c, 0x31, 0x34, 0xc5, 0x24, 0x20, 0x80, 0x25, 0xa6, 0x4c, 0x3c, 0x15, 0x09, 0x57,
                                        0x0b, 0x5e, 0x6d, 0xe3, 0x44, 0xc3, 0xdf, 0xb8, 0x1f, 0xde, 0x92, 0xb9, 0x47, 0xc5, 0x8d, 0xaa,
                                        0xab, 0xa9, 0xb4, 0x14, 0x30, 0x6e, 0x75, 0x40, 0x95, 0x9b, 0x94, 0x1a, 0xf9, 0xb8, 0x8c, 0x89,
                                        0x95, 0x48, 0xfe, 0xca, 0x69, 0x70, 0xc8, 0x72, 0x61, 0x67, 0x2f, 0x7c, 0x92, 0x81, 0x68, 0xe9,
                                        0x90, 0xf9, 0xc0, 0x38, 0x01, 0x01, 0xbb, 0x4b, 0x39, 0x1d, 0x68, 0xad, 0x23, 0x45, 0xbf, 0x43,
                                        0x56, 0x1b, 0x32, 0x60, 0x7c, 0x61, 0x38, 0xb1, 0xa0, 0x54, 0x14, 0x2c, 0x58, 0xe3, 0xe9, 0xb7,
                                        0x8e, 0x9f, 0x65, 0x55, 0xe1, 0xaf, 0xef, 0x44, 0xe1, 0xe1, 0xed, 0x48, 0xae, 0x5e, 0x68, 0xa6,
                                        0x1f, 0xd9, 0x3b, 0x5f, 0x8e, 0xab, 0x84, 0xf1, 0xb9, 0x21, 0xb0, 0x72, 0x5c, 0xa5, 0x4f, 0xc4,
                                        0x79, 0x59, 0xbf, 0x22, 0x18, 0x09, 0x54, 0x97, 0x2c, 0xe5, 0xb6, 0x37, 0x61, 0x74, 0xed, 0x06,
                                        0x44, 0x87, 0x07, 0x4d, 0x8c, 0x88, 0x88, 0x6b, 0x99, 0x21, 0x9b, 0xd6, 0x40, 0xab, 0xe4, 0x11,
                                        0xd1, 0xda, 0x51, 0xef, 0x68, 0x4c, 0x10, 0xbc, 0xa6, 0x48, 0xe1, 0xde, 0x12, 0x06, 0x3d, 0x09,
                                        0x42, 0x88, 0x23, 0xdc, 0x7c, 0xd0, 0x54, 0x03, 0x08, 0x74, 0x0c, 0x6e, 0x34, 0xc0, 0xd0, 0x35,
                                        0x8f, 0x22, 0xb1, 0xac, 0x0d, 0x51, 0x17, 0x93, 0xf4, 0xde, 0x81, 0x6a, 0x55, 0x42, 0x69, 0xeb,
                                        0x1d, 0xcb, 0xd8, 0x15, 0x01, 0x45, 0xba, 0x32, 0x6d, 0xfb, 0xba, 0x53, 0xfb, 0x64, 0x32, 0x3f,
                                        0x32, 0x84, 0x50, 0xd8, 0xb0, 0x8b, 0x6e, 0x76, 0x98, 0x56, 0x49, 0xc6, 0xb9, 0x23, 0x17, 0x2b,
                                        0xed, 0x9d, 0x36, 0xc7, 0x50, 0xb3, 0xcf, 0x98, 0xf1, 0xd7, 0x6f, 0x8f, 0x89, 0x83, 0xef, 0xd4,
                                        0x64, 0x3b, 0xef, 0xac, 0x99, 0xc6, 0x15, 0xcd, 0xfc, 0x63, 0xf9, 0x7c, 0x8c, 0xbc, 0xda, 0x49,
                                        0x6b, 0xb2, 0xd6, 0xe3, 0x3b, 0x75, 0x36, 0x8a, 0xe3, 0x93, 0x24, 0xe1, 0xbf, 0xd8, 0x25, 0xab,
                                        0x0d, 0xb5, 0x80, 0x91, 0xb6, 0x7b, 0x7c, 0x7f, 0xd4, 0x16, 0x40, 0xb9, 0xe4, 0xa3, 0xcd, 0x14,
                                        0xf3, 0x3b, 0xda, 0xdb, 0x87, 0xdc, 0x03, 0x2f, 0x9b, 0xd1, 0xd5, 0x54, 0x08, 0x2c, 0x22, 0x35,
                                        0x01, 0x45, 0xa4, 0x63, 0x29, 0x75, 0x8c, 0xff, 0x33, 0x99, 0xea, 0xc1, 0xac, 0x39, 0xaf, 0xb3,
                                        0x85, 0x98, 0x18, 0xf6, 0xf4, 0xbd, 0x6b, 0xf2, 0xc1, 0x9c, 0x29, 0x3e, 0x45, 0xcc, 0x7b, 0x47,
                                        0x75, 0x6c, 0x29, 0xd7, 0x02, 0x49, 0xba, 0xb5, 0x26, 0xd7, 0x8d, 0xe3, 0xb3, 0x5c, 0x35, 0x6f,
                                        0x0c, 0xf5, 0x7a, 0x8c, 0xb0, 0xf3, 0x86, 0xd0, 0x14, 0x98, 0xa6, 0xe3, 0x04, 0xff, 0x77, 0x7d,
                                        0x33, 0xd3, 0x44, 0xe8, 0x90, 0x24, 0xe6, 0x9a, 0x78, 0x90, 0x98, 0x09, 0xde, 0xea, 0x32, 0x60,
                                        0xa4, 0x1e, 0x33, 0x64, 0x40, 0xf0, 0x3e, 0x2b, 0x0a, 0xb1, 0x96, 0x3b, 0xab, 0x15, 0xb9, 0x47,
                                        0xde, 0x30, 0x03, 0x21, 0x16, 0x32, 0xef, 0x1d, 0x0e, 0xe3, 0xb0, 0x56, 0x38, 0xde, 0xb6, 0x7e,
                                        0x7c, 0x0b, 0x05, 0x76, 0xa4, 0xca, 0xc5, 0xc7, 0x4b, 0x7a, 0x28, 0xda, 0xad, 0xb3, 0xe2, 0x5e,
                                        0xa1, 0xb5, 0x4a, 0x60, 0xc0, 0x09, 0x0d, 0x3b, 0x0d, 0x19, 0xa4, 0xdf, 0x7f, 0x86, 0xc9, 0x47,
                                        0xd9, 0x1f, 0x6e, 0x84, 0xbf, 0x69, 0x3f, 0x9f, 0x89, 0x4c, 0x91, 0x29, 0xd5, 0xb6, 0xdc, 0x23,
                                        0x56, 0xf3, 0xde, 0x33, 0x9b, 0x54, 0xde, 0x86, 0xcc, 0xc7, 0xcf, 0x67, 0xa2, 0xb5, 0xcb, 0x57,
                                        0xfd, 0x7c, 0xd7, 0x48, 0x34, 0x99, 0x45, 0x9d, 0x2d, 0x13, 0xcd, 0x89, 0x1c, 0xc6, 0x0a, 0x2a,
                                        0x4a, 0xa0, 0xb3, 0x18, 0x0c, 0x1f, 0x42, 0x7f, 0x6c, 0x21, 0x3d, 0x1a, 0x9a, 0x20, 0x36, 0xca,
                                        0x8a, 0xd2, 0x85, 0xd8, 0xb4, 0x52, 0x1d, 0xcb, 0xd2, 0x95, 0xe4, 0x23, 0x23, 0xbc, 0x2e, 0xa0,
                                        0x22, 0xce, 0x87, 0xdc, 0xd9, 0x53, 0x8d, 0x75, 0x0c, 0xb0, 0xa5, 0x33, 0x91, 0xba, 0x62, 0x09,
                                        0xf4, 0xe1, 0x3c, 0xc3, 0x3a, 0x34, 0x13, 0xc0, 0x49, 0x58, 0xe7, 0xa1, 0x89, 0x96, 0xb7, 0x12,
                                        0x46, 0xf9, 0x6a, 0xad, 0x80, 0x7b, 0x75, 0x4f, 0xf0, 0x69, 0x95, 0xe4, 0xa4, 0xc5, 0x09, 0x4c,
                                        0xbc, 0x8b, 0x0b, 0x29, 0x16, 0xb0, 0xe1, 0xce, 0x6e, 0x53, 0x41, 0x3b, 0x33, 0x9a, 0x39, 0x79,
                                        0xeb, 0x37, 0x56, 0x34, 0xf1, 0x25, 0x24, 0x23, 0x2b, 0xa3, 0xb4, 0x66, 0xb8, 0xab, 0xe7, 0xe8,
                                        0xb9, 0x4a, 0x47, 0x8b, 0x99, 0xb9, 0x62, 0x40, 0xc5, 0x71, 0x7a, 0x7c, 0x80, 0x58, 0x53, 0xe1,
                                        0xdf, 0x26, 0x9c, 0xb1, 0xea, 0xf1, 0x00, 0x69, 0xbc, 0x49, 0x0b, 0x7d, 0x97, 0xe5, 0xcf, 0x8d,
                                        0x31, 0x23, 0x11, 0x0c, 0x95, 0xd5, 0x81, 0x6b, 0xd6, 0x08, 0x46, 0xef, 0x7e, 0x2e, 0xce, 0x43,
                                        0x42, 0xc5, 0xc5, 0x04, 0x1d, 0xd9, 0xdc, 0x45, 0xf7, 0x0b, 0x5e, 0xe9, 0x44, 0xf6, 0xde, 0x0d,
                                        0x48, 0x5f, 0x75, 0xb6, 0x01, 0x90, 0xbf, 0x6f, 0x33, 0x27, 0x83, 0xe1, 0x44, 0x95, 0x40, 0xb5,
                                        0xf6, 0xaf, 0x94, 0xed, 0x13, 0xcf, 0x58, 0xd3, 0x13, 0xae, 0x29, 0x9c, 0xc2, 0xba, 0x6e, 0x93,
                                        0x9a, 0x96, 0x68, 0x51, 0x53, 0xa9, 0x48, 0x53, 0x5c, 0x7d, 0x9b, 0x55, 0x1f, 0xa9, 0xeb, 0xe8,
                                        0x6e, 0xca, 0x7b, 0x57, 0x3b, 0x2d, 0xa1, 0x61, 0x73, 0x8d, 0xe4, 0x30, 0x89, 0x19, 0xa7, 0x8e,
                                        0xb3, 0xd1, 0x5e, 0x5a, 0x6c, 0x13, 0x2d, 0x59, 0x50, 0x93, 0x01, 0x23, 0xb9, 0xe7, 0x2c, 0xca,
                                        0xfe, 0x89, 0xd7, 0x14, 0x26, 0x8e, 0xcd, 0x4e, 0x8c, 0x44, 0xb7, 0xea, 0x28, 0xb8, 0xdb, 0xf8,
                                        0x7d, 0x96, 0xd2, 0x18, 0x49, 0xf1, 0x6a, 0x0a, 0x59, 0x25, 0xc9, 0x54, 0x40, 0x59, 0xb6, 0x57,
                                        0x92, 0x83, 0xac, 0x85, 0x20, 0xb9, 0x66, 0x50, 0x23, 0xda, 0xd6, 0x0f, 0xdd, 0x47, 0x57, 0x0b,
                                        0x26, 0x05, 0x46, 0xda, 0x67, 0x6a, 0x01, 0x73, 0x3c, 0xeb, 0x72, 0xf7, 0x60, 0x34, 0x5a, 0x4e,
                                        0xf7, 0xfc, 0x4d, 0x1e, 0x65, 0x6a, 0x01, 0xd4, 0x3b, 0x26, 0x96, 0xb4, 0x4c, 0x35, 0x12, 0x66,
                                        0x75, 0xc0, 0x40, 0xd2, 0x52, 0x2c, 0x13, 0xb8, 0x49, 0x9c, 0x64, 0x32, 0x32, 0xa5, 0x39, 0x9e,
                                        0x00, 0x18, 0xd9, 0x99, 0xf8, 0x8f, 0x5a, 0x8b, 0xbc, 0x44, 0x4a, 0xc7, 0x13, 0xf5, 0x62, 0x5f,
                                        0xa1, 0xaa, 0x52, 0xf5, 0x29, 0xfc, 0x1e, 0x09, 0xa4, 0x0d, 0x03, 0xe1, 0x4a, 0x43, 0xb9, 0xa9,
                                        0x92, 0xb9, 0x53, 0x42, 0x8d, 0x15, 0xa0, 0xb1, 0xab, 0x49, 0xc0, 0x58, 0x09, 0xf5, 0x64, 0x08,
                                        0xa0, 0xd8, 0x1e, 0xa1, 0xfc, 0x41, 0x2d, 0x37, 0x26, 0xd9, 0xc7, 0xa8, 0x44, 0xc1, 0x6b, 0x19,
                                        0x8d, 0x76, 0x3f, 0x06, 0x22, 0x6d, 0x3a, 0x47, 0x52, 0x2e, 0x16, 0x8e, 0x55, 0x60, 0x94, 0x4a,
                                        0x5d, 0xcb, 0xe3, 0xfd, 0x04, 0x76, 0x85, 0xb0, 0xa3, 0x56, 0x76, 0x58, 0x54, 0xc9, 0xcd, 0xa6,
                                        0xf4, 0x29, 0xa9, 0xb6, 0xd4, 0xa4, 0xc1, 0x3c, 0x4c, 0xb9, 0xa1, 0x96, 0x5d, 0x88, 0x3a, 0xf6,
                                        0xb7, 0x9d, 0x96, 0xb9, 0x9d, 0x40, 0xd4, 0xf9, 0x8b, 0x6f, 0x47, 0x3a, 0xae, 0x70, 0x0c, 0xa8,
                                        0x05, 0x79, 0x85, 0x5b, 0x0f, 0x79, 0x98, 0xc7, 0x63, 0xb6, 0xf2, 0xba, 0x85, 0x6c, 0x13, 0xdc,
                                        0x45, 0xf9, 0xed, 0xb1, 0xba, 0xaf, 0xd2, 0xfa, 0xcc, 0x89, 0x35, 0x79, 0xff, 0x1f, 0x56, 0xab,
                                        0xaa, 0x65, 0xc0, 0x3d, 0x6b, 0xf8, 0x04, 0xff, 0x6c, 0x4d, 0x6b, 0xdc, 0x32, 0xd3, 0xc7, 0x6e,
                                        0x5e, 0x50, 0xe7, 0x12, 0x90, 0x2e, 0x51, 0x20, 0xcb, 0xdf, 0x73, 0x69, 0x9e, 0xaf, 0x76, 0x7a,
                                        0x38, 0x95, 0xc7, 0xd1, 0xea, 0x8b, 0x31, 0x32, 0x7a, 0x77, 0xd8, 0x6d, 0xc8, 0x93, 0xd5, 0x58,
                                        0x2b, 0xe1, 0x56, 0xca, 0x03, 0x15, 0x17, 0xd8, 0x65, 0x26, 0x43, 0xd9, 0xc9, 0x1f, 0xcf, 0x36,
                                        0x44, 0x38, 0x44, 0x54, 0x02, 0xec, 0xc5, 0xfa, 0x08, 0x9d, 0xfc, 0x91, 0x96, 0x5c, 0x7d, 0xde,
                                        0xe2, 0xdb, 0x8f, 0x79, 0x50, 0x2c, 0x33, 0x9b, 0x60, 0xfe, 0xae, 0xcb, 0xc3, 0xa2, 0x9c, 0x32,
                                        0xf1, 0x0c, 0x3b, 0xa3, 0xca, 0x39, 0x47, 0x19, 0xa5, 0xc3, 0x8e, 0xe4, 0x4d, 0x94, 0xd6, 0x13,
                                        0x00, 0xd2, 0x63, 0x88, 0x27, 0xde, 0xec, 0x3a, 0x74, 0x6c, 0xb2, 0x8c, 0xad, 0xb2, 0x99, 0x1a,
                                        0x3f, 0xd8, 0x1a, 0x60, 0x3d, 0xc1, 0xf4, 0x95, 0xa4, 0xb2, 0x54, 0x89, 0xc5, 0x2a, 0x02, 0x2a,
                                        0x82, 0x12, 0xb7, 0xbb, 0x86, 0x4f, 0x2a, 0xeb, 0x8e, 0xed, 0xbe, 0xc2, 0xf2, 0x11, 0xc7, 0x00,
                                        0x0b, 0xd5, 0x31, 0xf3, 0xfc, 0x35, 0x94, 0x6b, 0x28, 0xef, 0x11, 0xaf, 0xa8, 0x01, 0x04, 0x6b,
                                        0x20, 0xbc, 0x42, 0x79, 0xd0, 0x96, 0x34, 0x5d, 0xe5, 0x5e, 0x2b, 0xe2, 0xb1, 0xb3, 0x21, 0x57,
                                        0xe3, 0x9e, 0x69, 0x21, 0x1e, 0x6b, 0x0e, 0x31, 0x2c, 0x2b, 0x6d, 0x11, 0x50, 0xad, 0x36, 0xaf,
                                        0x0a, 0x48, 0x5e, 0x46, 0xfd, 0xc7, 0xc8, 0xc1, 0x2c, 0xa4, 0xf2, 0xcf, 0xea, 0x01, 0x07, 0xb7,
                                        0x1c, 0xf6, 0xc6, 0xe2, 0x2e, 0xe2, 0xf5, 0xfc, 0xd1, 0xe0, 0x16, 0x51, 0xce, 0xb5, 0xc7, 0x39,
                                        0x94, 0x69, 0x76, 0x3b, 0x46, 0x4a, 0x97, 0x6e, 0xca, 0x1e, 0xca, 0xdb, 0x14, 0xd9, 0x19, 0xdb,
                                        0x5a, 0x31, 0x48, 0x75, 0xcc, 0x35, 0x74, 0x0e, 0x74, 0xd3, 0x3c, 0x5f, 0xe8, 0xf0, 0xf1, 0x2a,
                                        0xc9, 0xab, 0x7e, 0x1c, 0x20, 0x13, 0xe6, 0xa1, 0x62, 0xc0, 0x25, 0xf4, 0xd1, 0xe7, 0xd6, 0xb5,
                                        0x44, 0x38, 0x92, 0xf0, 0x4d, 0x6e, 0x15, 0xc0, 0x6b, 0x68, 0xc1, 0x0b, 0x19, 0x68, 0x12, 0x6b,
                                        0x4e, 0xec, 0x1a, 0x5b, 0xf8, 0x73, 0x8b, 0x7f, 0x2c, 0xd0, 0x71, 0xea, 0xaf, 0x58, 0x51, 0x79,
                                        0x46, 0x06, 0xaa, 0x8b, 0x88, 0xbe, 0x39, 0x2d, 0xc0, 0x76, 0xba, 0xd8, 0x20, 0x5f, 0x7a, 0x84,
                                        0x5a, 0x36, 0xd5, 0x58, 0x9c, 0x1f, 0xd7, 0x96, 0xa4, 0xb2, 0x14, 0xf9, 0x02, 0x7d, 0x38, 0xb2,
                                        0x31, 0xf5, 0x3c, 0x87, 0xed, 0xb7, 0xba, 0x13, 0xb8, 0x96, 0xc0, 0x7a, 0xa8, 0xd9, 0x06, 0x1b,
                                        0xa0, 0x17, 0xd2, 0x35, 0x97, 0x11, 0xa5, 0xb8, 0xa6, 0xc4, 0x60, 0xc2, 0x06, 0xb4, 0x2a, 0xcb,
                                        0x79, 0xf4, 0x26, 0x74, 0x72, 0x14, 0x7a, 0xdd, 0x98, 0x8c, 0xde, 0x21, 0x88, 0xcf, 0xd3, 0x22,
                                        0xdb, 0x52, 0x71, 0x90, 0x8b, 0xa5, 0xd2, 0xfa, 0x38, 0x74, 0xac, 0xe6, 0x72, 0xb5, 0x36, 0x51,
                                        0x4a, 0x46, 0x76, 0x31, 0xe9, 0xb1, 0x97, 0x5a, 0xef, 0xf7, 0x84, 0x6b, 0xc5, 0x3d, 0x14, 0x2e,
                                        0x1f, 0x74, 0x71, 0x3d, 0x81, 0x4e, 0x25, 0xa2, 0x03, 0x04, 0x39, 0xec, 0x68, 0x13, 0x03, 0x23,
                                        0x6e, 0xac, 0xe1, 0xbc, 0xbc, 0xc3, 0x40, 0x8f, 0xf0, 0x2d, 0x5a, 0x63, 0x88, 0xe7, 0x3b, 0xf8,
                                        0x22, 0x89, 0x17, 0x09, 0xf8, 0x94, 0x9e, 0x9c, 0x3e, 0xe5, 0x80, 0xe4, 0xa3, 0x89, 0x95, 0x76,
                                        0x63, 0x78, 0xb8, 0x82, 0x35, 0xaf, 0xb4, 0x53, 0xe0, 0x77, 0x28, 0x19, 0xbb, 0x78, 0x2e, 0x5f,
                                        0x84, 0xec, 0x17, 0xf7, 0x72, 0x63, 0xf7, 0x91, 0x75, 0xb3, 0x2b, 0x68, 0xbd, 0xa7, 0x48, 0x2c,
                                        0xdd, 0xd4, 0x15, 0x2d, 0x44, 0x7d, 0x98, 0x17, 0xa8, 0xbf, 0x49, 0x2c, 0xc5, 0x34, 0x21, 0xd6,
                                        0xce, 0xdb, 0x22, 0x43, 0x2c, 0x28, 0x96, 0x34, 0x6b, 0x54, 0x7a, 0xf2, 0x03, 0xec, 0xce, 0x98,
                                        0xfe, 0x81, 0xa3, 0x6b, 0x36, 0xe0, 0x8b, 0x14, 0x59, 0xd9, 0x78, 0xa2, 0xec, 0xde, 0xf3, 0xed,
                                        0x57, 0x1f, 0xed, 0x94, 0x1f, 0x50, 0x64, 0x1f, 0x66, 0x9d, 0xad, 0x15, 0xfe, 0x2b, 0x61, 0x7f,
                                        0xb0, 0xfd, 0xae, 0xd4, 0x5f, 0xd4, 0x6d, 0x90, 0x9e, 0xb4, 0x5e, 0x40, 0xf4, 0xbb, 0xc5, 0xdd,
                                        0x99, 0x38, 0x2b, 0x7b, 0x96, 0x66, 0x23, 0xbb, 0xc0, 0xe6, 0x5a, 0x37, 0x74, 0xdf, 0x7d, 0xc7,
                                        0xa4, 0x5b, 0xe9, 0xf3, 0xa7, 0x5b, 0xda, 0x95, 0xf6, 0x09, 0xbb, 0xd2, 0x7f, 0x54, 0x85, 0x61,
                                        0x8f, 0x99, 0x2a, 0xc7, 0x62, 0x6b, 0xb2, 0x47, 0xb3, 0xc7, 0xe8, 0xea, 0x31, 0xd6, 0xca, 0xa8,
                                        0x78, 0x27, 0x7d, 0x3e, 0xe5, 0x97, 0x8a, 0x9d, 0x5b, 0x63, 0xb5, 0x59, 0x26, 0x2c, 0x6d, 0x1d,
                                        0x65, 0x35, 0x47, 0xbd, 0xdd, 0x6f, 0x3d, 0xd5, 0x32, 0xe7, 0x84, 0x80, 0x3e, 0x61, 0xf3, 0x47,
                                        0xa7, 0x55, 0xe6, 0x86, 0xf2, 0xb5, 0xba, 0x09, 0x8e, 0x63, 0x61, 0x55, 0xe1, 0xfc, 0x9f, 0x59,
                                        0x8a, 0xde, 0x63, 0xbf, 0x3b, 0x90, 0x9c, 0xf3, 0x8c, 0xa5, 0xf6, 0xe9, 0x96, 0xc6, 0xbf, 0x5e,
                                        0x72, 0xbf, 0xb8, 0xf6, 0xe6, 0x12, 0x1d, 0xc4, 0x6b, 0xb6, 0x51, 0x76, 0x51, 0x76, 0xda, 0x8a,
                                        0xe2, 0x71, 0x09, 0xc3, 0x6a, 0x80, 0x9a, 0xec, 0xc3, 0x12, 0x37, 0x37, 0x4a, 0x5e, 0xa5, 0xdc,
                                        0x5c, 0x61, 0xf4, 0x27, 0xd3, 0x64, 0xb3, 0xf7, 0x4b, 0xd6, 0xa3, 0xfe, 0x96, 0xf2, 0xd7, 0x94,
                                        0x1f, 0xda, 0x8f, 0x2b, 0xee, 0xb0, 0x9b, 0x57, 0xe2, 0x91, 0xd7, 0x5b, 0x70, 0xb0, 0x49, 0xba,
                                        0x85, 0x32, 0x60, 0x77, 0x1b, 0x6e, 0xb3, 0x03, 0x74, 0xa7, 0xd9, 0x91, 0x07, 0x5e, 0xa2, 0x5c,
                                        0x4e, 0xf9, 0xa3, 0x6a, 0x80, 0xae, 0xb6, 0x26, 0x7e, 0xd2, 0xee, 0xbd, 0x3c, 0x63, 0xcd, 0xbb,
                                        0xfa, 0x24, 0x00, 0xba, 0xd0, 0x1e, 0xbf, 0x66, 0xeb, 0xb4, 0xbf, 0xa0, 0x7c, 0x9c, 0x72, 0x84,
                                        0xf2, 0x3e, 0x9b, 0x70, 0xd7, 0x5a, 0x97, 0x5a, 0x69, 0xef, 0xbd, 0xc8, 0x9e, 0x7f, 0xda, 0x56,
                                        0x1e, 0xd2, 0xbe, 0x41, 0xf9, 0x63, 0xca, 0x9f, 0x52, 0x7e, 0xc7, 0x9e, 0x5b, 0x58, 0x09, 0x90,
                                        0xb2, 0x37, 0xc8, 0x28, 0x7d, 0xc7, 0x9e, 0xff, 0x67, 0xfb, 0xff, 0xcd, 0x27, 0x01, 0x50, 0x8b,
                                        0x3d, 0x0e, 0x97, 0xa5, 0xb4, 0x21, 0x1b, 0x97, 0xf5, 0x25, 0xfd, 0xae, 0xb6, 0xd5, 0xc5, 0x1c,
                                        0xbb, 0x39, 0x3c, 0x82, 0xf8, 0x43, 0xa9, 0x72, 0x17, 0x76, 0xab, 0xd5, 0xf5, 0x8e, 0x1d, 0xc1,
                                        0x65, 0xf6, 0xe2, 0x97, 0x6d, 0x49, 0x72, 0x87, 0xfd, 0xff, 0xa2, 0x92, 0x11, 0xae, 0xb5, 0xf9,
                                        0x65, 0x9d, 0xe9, 0x71, 0xf2, 0xb4, 0xb6, 0x0a, 0x4b, 0x2a, 0xd8, 0x04, 0xf9, 0xee, 0x0e, 0xf8,
                                        0x94, 0xbd, 0xfe, 0xc4, 0x38, 0x93, 0x92, 0xaa, 0xef, 0x76, 0xec, 0x8c, 0x50, 0xd9, 0x40, 0x43,
                                        0x49, 0x61, 0xb9, 0xdb, 0x9e, 0xff, 0xf4, 0x04, 0x8a, 0x95, 0xb6, 0x86, 0x92, 0x40, 0x2d, 0x4e,
                                        0xcc, 0xba, 0xed, 0x71, 0x7a, 0xe9, 0x4c, 0xc0, 0x5a, 0x6e, 0xd8, 0x5a, 0x01, 0x76, 0xca, 0x20,
                                        0xb1, 0xfc, 0xc9, 0x5a, 0x56, 0x48, 0xab, 0x81, 0x4d, 0x58, 0x7f, 0x96, 0xb6, 0x8a, 0xf2, 0x66,
                                        0xc9, 0x4d, 0xf3, 0xec, 0x4a, 0xe5, 0x75, 0x36, 0xf8, 0x82, 0x12, 0x65, 0x4a, 0xcb, 0xa6, 0x62,
                                        0x2a, 0x79, 0xca, 0xae, 0xcc, 0x14, 0x29, 0xb5, 0xf8, 0x29, 0xcb, 0x73, 0x76, 0x30, 0x24, 0x7e,
                                        0xce, 0xb4, 0x55, 0xf6, 0x02, 0x3b, 0xdd, 0xb8, 0xdf, 0xc6, 0x4a, 0x11, 0xd0, 0x9f, 0x5b, 0x37,
                                        0x14, 0x16, 0x7c, 0xa3, 0x64, 0x42, 0x59, 0x7a, 0x2c, 0x8d, 0xfd, 0x94, 0xed, 0xfb, 0xbd, 0xd6,
                                        0x75, 0x07, 0x1d, 0x0b, 0xe2, 0x1f, 0xcb, 0xc0, 0xc0, 0x52, 0xe4, 0x37, 0xec, 0xf9, 0xc8, 0x5a,
                                        0x4c, 0x3a, 0x79, 0xb6, 0x64, 0x59, 0x56, 0xbe, 0x96, 0x7a, 0xc1, 0x2a, 0x2c, 0x8c, 0x74, 0xd0,
                                        0x4e, 0x9d, 0x25, 0x16, 0x7e, 0x6a, 0xef, 0xdb, 0x6c, 0x07, 0xed, 0x55, 0xca, 0xaf, 0xda, 0xea,
                                        0x42, 0xf2, 0xce, 0xb7, 0x29, 0x7f, 0x52, 0xd2, 0xdf, 0x3b, 0x96, 0x8c, 0x8a, 0x83, 0x50, 0x8c,
                                        0xb9, 0xd7, 0x2a, 0x2c, 0x01, 0x1f, 0xb0, 0x6e, 0xba, 0xde, 0xa6, 0x09, 0xf1, 0x2e, 0xd9, 0xb4,
                                        0xea, 0x91, 0xd2, 0xc7, 0x2d, 0xc9, 0x1d, 0x15, 0xab, 0x89, 0x92, 0xeb, 0x89, 0xb2, 0x69, 0xb1,
                                        0x87, 0x1a, 0xbf, 0x92, 0x2a, 0x49, 0xc2, 0x8e, 0xb5, 0x52, 0xf9, 0x7b, 0xd6, 0x58, 0x06, 0x94,
                                        0x6f, 0xf2, 0xe4, 0x13, 0x98, 0x47, 0x4b, 0x67, 0xdd, 0x15, 0xd6, 0x16, 0x2a, 0xea, 0x9d, 0x98,
                                        0x00, 0x0c, 0xca, 0xae, 0x07, 0x55, 0x08, 0xa0, 0xd6, 0x96, 0xad, 0x72, 0xbe, 0xcd, 0x7a, 0x89,
                                        0xe8, 0x23, 0x9f, 0x93, 0xfd, 0xf8, 0x98, 0x45, 0xe9, 0xf1, 0xf5, 0x1a, 0x6b, 0xff, 0x27, 0xc0,
                                        0x00, 0x92, 0xa3, 0x5e, 0x7e, 0xf1, 0xc4, 0xde, 0xa7, 0x00, 0x00, 0x00, 0x00, 0x49, 0x45, 0x4e,
                                        0x44, 0xae, 0x42, 0x60, 0x82 };

        qcc::String mimeType("image/png");
        qcc::String url("https://www.alljoyn.org/sites/all/themes/at_alljoyn/images/img-alljoyn-logo.png");


        std::vector<qcc::String> interfaces;
        interfaces.push_back("org.alljoyn.Icon");
        aboutService->AddObjectDescription("/About/DeviceIcon", interfaces);


        aboutIconService = new AboutIconService(*s_msgBus, mimeType, url, aboutIconContent, sizeof(aboutIconContent) / sizeof (*aboutIconContent));
        aboutIconService->Register();

        status = s_msgBus->RegisterBusObject(*aboutIconService);



    }



    const TransportMask SERVICE_TRANSPORT_TYPE = TRANSPORT_ANY;

    if (ER_OK == status) {
        status = CreateSession(SERVICE_TRANSPORT_TYPE);
    }


    if (ER_OK == status) {
        status = AdvertiseName(SERVICE_TRANSPORT_TYPE);
    }

    if (ER_OK == status) {
        status = aboutService->Announce();

    }


    /* Perform the service asynchronously until the user signals for an exit. */
    if (ER_OK == status) {
        WaitForSigInt();
    }


    /* Clean up msg bus */
    delete s_msgBus;
    s_msgBus = NULL;

    if (!aboutService) {
        delete aboutService;
        aboutService = NULL;
    }

    if (!aboutIconService) {
        delete aboutIconService;
        aboutIconService = NULL;
    }


    if (!propertyStoreImpl) {
        delete propertyStoreImpl;
        propertyStoreImpl = NULL;

    }



    return 0;
} /* main() */




